#include <stdint.h>
#include "convert.h"
#include "state.h"

int32_t convert(int32_t a, uint8_t i) {
    uint32_t c, v;
    int32_t z;
    int8_t neg;

    if (i == E)
        a = a * s.extrusion_area / PRECISION;

    neg = a < 0;
    c = neg ? -a : a;
    c <<= convert_table[i].s;
    v = convert_table[i].v;

    z = 0;
    for (i = 31; i > 0; i--) {
        if (c & 0x80000000UL)
            z += v;
        c <<= 1;
        v >>= 1;
    }

    if (i == INV_E)
        z = z * PRECISION / s.extrusion_area;

    return neg ? -z : z;
}
