#include <stdint.h>
#include "convert.h"
#include "dist.h"
#include "state.h"

uint16_t sqrt32(uint32_t x) {
    uint16_t z, b;
    z = 0;
    for (b = 1<<15; b > 0; b >>= 1)
        if ((uint32_t)(z + b) * (z + b) <= x)
            z += b;
    return z;
}

uint32_t dist_steps(int32_t *_xyz) {
    /* convert x y z into mm, then calculate distance
       '/ 256' means that the maximum distance before overflow is about 1600mm */
    uint32_t h = 0;
    FOREACH_XYZ(i) {
        uint32_t d = convert(_xyz[i], i + INV) / 256;
        h += d * d;
    }
    return (uint32_t)sqrt32(h) * 256;
}

uint32_t dist_steps_xy(int32_t *_xy) {
    uint32_t h = 0;
    FOREACH_XY(i) {
        uint32_t d = convert(_xy[i], i + INV) / 256;
        h += d * d;
    }
    return (uint32_t)sqrt32(h) * 256;
}
