#ifndef __HW_H__
#define __HW_H__
#include <libavr/device.h>

#define F_CPU                   16000000UL

/* fan */
#define BIT_FAN                 7 // SCK - SDcard
#define PORT_FAN                B

/* valve */
#define BIT_VALVE               7 // SCK - SDcard
#define PORT_VALVE              B

/* heater stuff */
/* mosfets */
#define BIT_BED                 4 // SS - SDcard
#define BIT_EXTRUDER            5 // MOSI - SDcard
#define PORT_BED                B
#define PORT_EXTRUDER           B
/* thermistors*/
#define BIT_ADC_BED             0 // A0 - max Z
#define BIT_ADC_EXTRUDER        5 // A5 - max Y
#define PORT_ADC_BED            A
#define PORT_ADC_EXTRUDER       A
#define ADC_BED                 0
#define ADC_EXTRUDER            5

/* motors */
#define BIT_ENABLE_X            3 // D19
#define BIT_ENABLE_Y            7 // A7
#define BIT_ENABLE_Z            2 // A2
#define BIT_ENABLE_E            5 // D21 - max X
#define PORT_ENABLE_X           C
#define PORT_ENABLE_Y           A
#define PORT_ENABLE_Z           A
#define PORT_ENABLE_E           D
#define BIT_DIR_X               2 // D18
#define BIT_DIR_Y               6 // D22
#define BIT_DIR_Z               3 // A3
#define BIT_DIR_E               0 // D16 - SCL
#define PORT_DIR_X              C
#define PORT_DIR_Y              C
#define PORT_DIR_Z              A
#define PORT_DIR_E              C
#define BIT_STEP_X              7 // D15
#define BIT_STEP_Y              7 // D23
#define BIT_STEP_Z              4 // A4
#define BIT_STEP_E              1 // D17 - SDA
#define PORT_STEP_X             D
#define PORT_STEP_Y             C
#define PORT_STEP_Z             A
#define PORT_STEP_E             C
#define BIT_MIN_X               4 // D20
#define BIT_MIN_Y               6 // A6
#define BIT_MIN_Z               1 // A1
#define PORT_MIN_X              D
#define PORT_MIN_Y              A
#define PORT_MIN_Z              A

/* debugging */
#define BIT_LED                 0 // D0
#define PORT_LED                B

/* RS485 uart */
#define BIT_RE                  5 // D13
#define BIT_DE                  4 // D12
#define PORT_RE                 D
#define PORT_DE                 D
// RXD, TXD are on PORTD2, PORTD3 (D10, D11)

#endif
