#include <math.h>
#include <stdio.h>
#include "../config.h"

int temp_from_adc(int adc) {
    const double r0 = THERMISTOR_R0_OHMS;
    const double t0 = THERMISTOR_T0_DEG_C;
    const double beta = THERMISTOR_BETA;
    const double r1 = THERMISTOR_R1_OHMS;
    const double r2 = THERMISTOR_R2_OHMS;

    const double vcc = 5;
    const double vadc = 5;
    const double zero = 273.15;
    double vs, rs, v, r, k;

    if (r1 > 0) {
        vs = r1 * vcc / (r1 + r2);
        rs = r1 * r2 / (r1 + r2);
    } else {
        vs = vcc;
        rs = r2;
    }
    if (adc == 0)
        adc = 1;
    v = vadc * adc / 1024;
    r = rs * v / (vs - v);
    k = r0 * exp(-beta / (t0 + zero));
    return beta / log(r / k) - zero;
}

int main(void) {
    int adc;

    printf("#include <libavr/flash.h>\n");
    printf("flash_int16_t heater_table[] = {");
    for (adc = 0; adc < 1024; adc++) {
        if (adc > 0)
            printf(", ");
        if (adc % 16 == 0)
            printf("\n\t");
        printf("%d", temp_from_adc(adc));
    }
    printf("};\n");
}
