#include <inttypes.h>
#include <stdint.h>
#include <stdio.h>
#include "config.h"
#include "motor.h"
#include "state.h"

void table(char *x, double spu, int inv) {
    int32_t u, v, bit;

    u = 0;
    for (bit = 0; ; bit++) {
        v = spu * (1<<bit) / PRECISION;
        if (v < 0)
            break;
        u = v;
    }
    printf("\t[%s] = {%"PRId32"UL, %"PRId32"},\n", x, u, 32-bit);

    if (!inv)
        return;

    u = 0;
    for (bit = 0; ; bit++) {
        v = ((double)PRECISION) * (1<<bit) / spu;
        if (v < 0)
            break;
        u = v;
    }
    printf("\t[INV_%s] = {%"PRId32"UL, %"PRId32"},\n", x, u, 32-bit);
}

int main(void) {
    printf("#include \"convert.h\"\n\n");
    printf("#include \"state.h\"\n\n");
    printf("struct convert convert_table[] = {\n");
    table("X", STEPS_PER_MM_X, 1);
    table("Y", STEPS_PER_MM_Y, 1);
    table("Z", STEPS_PER_MM_Z, 1);
    table("E", STEPS_PER_CUBIC_MM_E, 1);
    table("INCH_MM", 25.4 * PRECISION, 1);
    table("INCH2_MM2", 25.4 * 25.4 * PRECISION, 0);
    printf("};\n");
    return 0;
}
