#include <stdint.h>

#define UNITS_MM 0
#define UNITS_INCHES 1

enum {
    INCH_MM, X, Y, Z, E, INCH2_MM2,
    INV_INCH_MM, INV_X, INV_Y, INV_Z, INV_E,
};
#define T 0
#define F 0
#define S 5
#define INV INV_INCH_MM

#define FOREACH_TXYZE(V) FOREACH_FXYZE(V)
#define FOREACH_FXYZE(V) for(int8_t V = 0; V < 5; V++)
#define FOREACH_XYZE(V) for(int8_t V = 1; V < 5; V++)
#define FOREACH_XYZ(V) for(int8_t V = 1; V < 4; V++)
#define FOREACH_XY(V) for(int8_t V = 1; V < 3; V++)

#define UNSEEN 0x80000000UL
#define BED 0xFF

#define PRECISION_DP 4
#define PRECISION 10000L
#define PRECISION_EXTRUDER 131 // precision for steps_per_mm*extruder_k = exp2(72) / (60^2*PRECISION^4)

#define US_IN_S 1000000L
#define US_IN_MIN 60000000L

struct state {
    uint8_t g, t; // last g code seen and last tool used
    int32_t n; // last line number seen
    int32_t fxyze[5]; // current position (in steps for XYZE, in mm/min * PRECISION for F)
    int8_t units;
    int8_t rel; // 0 = absolute positions, 1 = relative
    int8_t extruding;
    int32_t extrusion_area; // in mm2 * PRECISION
    int32_t extruder_advance; // steps_per_cubic_mm * extruder_advance_k * PRECISION_EXTRUDER
};

extern struct state s;
