#include "uart.h"

static void uart_putn(int32_t x, int8_t d) {
    char c[10];
    int i = 10;

    if (x < 0) {
        uart_putc('-');
        x = -x;
    }

    do {
        c[--i] = (x % 10) + '0';
        x /= 10;
    } while (x > 0 || (d && i > 5));

    while (i < 10) {
        if (d && i == 6)
            uart_putc('.');
        uart_putc(c[i++]);
    }
}

void uart_puti(int32_t x) {
    uart_putn(x, 0);
}

void uart_putd(int32_t x) {
    uart_putn(x, 1);
}

void uart_report(uint8_t x) {
    uart_putc(' ');
    uart_putc(x);
    uart_putc(':');
}
